{$V-}
Unit Calc_S;

interface

procedure Calculations(var Stroka: string);
{ ᮡ⢥  :  Stroka
  । ⠭ ப-ࠦ;
     頥 १   ப ᨬ }
var
  Success    : boolean; { true - ᫨ ᫥ 襭 ᯥ譮 }
  ErrorCode  : byte;    {  訡, ᫨ Success=false.
                         ⥪⮢ ᮮ饭 ᯮ
                        ᨢ ErrorMessages, ਢ .
		   }
const
  ErrorMessages: array[1..6] of string[42] =
                  (
                   '訡  ࠦ.',
                   'ᯮ짮 ⨬ ᨬ.',
                   '誮  ࠦ.',
                   'ᮣᮢ ᪮.',
                   '  .',
                   '୮ e⢨  ⥫ ᫮.'
                   );


implementation

const
  StackSize   = 40; { ᨬ쭮 ᫮ ᥬ  ࠦ }
  ElementSize = 23; { ᨬ쭮 ᫮   ᥬ -   !!! }
type
  SetOfChar = set of char;
  { ⨯ ᥬ }
  Token = (number,plus,minus,ast,dvt,lparen,rparen,step,
           _sin,_cos,_tg,_ln,_exp,_sqrt);

  { ⨯  ⥪ }
  Element = record
                TextElement: string[ElementSize];
                TypeElement: Token;
              end;
  { ⨯ ⥪ }
  Maneger = record
              StackBody : array[1..StackSize] of Element;
              StackCount: byte;
            end;
const
  Operations: set of Token = [plus,minus,ast,dvt,step];
  Functions : set of Token = [_sin,_cos,_tg,_ln,_exp,_sqrt];
  Digits    : SetOfChar = ['0'..'9','.'];
  Letters   : SetOfChar = ['A'..'Z'];
var
  Stack      : Maneger; { ⥪ }
  ScanStr    : string;  { ࠧࠥ ப }
  ScanLength : Word;	  {   }
  ScanCount  : Word;	  { 稪 ᨬ }
  ch         : char;	  { ⥪騩 ᨬ }
  Counter    : Byte;	  { 稪 ᪮ }
  sym        : Token;	  { ⨯ ᥬ }
  Lexeme     	  { ⥪ ᥬ }
  	     : string[ElementSize];	

{******* Common procedures ***********}
function ToStr(r: real): string;
var
  s: string;
begin
  Str(r, s);
  ToStr := s;
end;

procedure InitStack;
{    樠 ⥪   }
var
  i : byte;
begin
  Success := true;
  Stack.StackCount := 0;
  for i:=1 to StackSize do Stack.StackBody[i].TextElement := '';
end;

procedure InStack(S: string; T: Token);
{      ⥪ ࠢ   }
begin
  Success := false;
  ErrorCode := 3;
  if Stack.StackCount=StackSize then Exit;
  with Stack do begin
    inc(StackCount);
    StackBody[StackCount].TextElement := S;
    StackBody[StackCount].TypeElement := T;
  end;
  Success := true;
end;

procedure FromStack(var op1,op2,opr: Element;
                    NumElements: byte);
{ 祭  ⥪ ࠭   樨 :
     NumElements - ᪮쪮 ࠭,
     op1,op2  - ࠭,
     opr      -  }
var
  i, j: byte;
begin
  Success := false;
  ErrorCode := 1;
  with Stack do begin
    if Counter<=NumElements then Exit;
    opr := StackBody[Counter  ];
    op2 := StackBody[Counter-1];
    if NumElements=2 then op1 := StackBody[Counter-2]
    		     else op1.TextElement := '0';
    for j:=1 to NumElements do begin
      for i:=Counter to StackCount-1 do StackBody[i] := StackBody[i+1];
      StackBody[StackCount].TextElement:='';
      dec(StackCount);
      dec(Counter);
    end;
  end;
  Success := true;
end;

procedure Scan;
{ ᪠ -   sym ⨯ ᥬ,   Lexeme  ⥪ }
var
  Check: Boolean;
begin
  if ScanCount > ScanLength then Exit;

  repeat
    ch := ScanStr[ScanCount];
    if ch = ' ' then inc(ScanCount);
  until ch <> ' ';

  Check := true;
  if ch in ['0'..'9','.'] then begin   { ᫮ }
    sym := number;
    Lexeme := '';
    while ch in ['0'..'9','.'] do begin
      if Length(Lexeme)=ElementSize then begin
         Success := false;
         ErrorCode := 3;
         Exit;
      end;
      Lexeme := Lexeme + ch;
      inc(ScanCount);
      if ScanCount > ScanLength then Exit;
      ch := ScanStr[ScanCount];
    end;
  end
  else
   if UpCase(ch) in ['A'..'Z'] then begin    { ⥪ }
     Lexeme := '';
     while UpCase(ch) in ['A'..'Z'] do begin
       if Length(Lexeme)=ElementSize then begin
          Success := false;
          ErrorCode := 3;
          Exit;
       end;
       Lexeme := Lexeme + UpCase(ch);
       if ScanCount > ScanLength then Exit;
       inc(ScanCount);
       ch := ScanStr[ScanCount];
     end;

     if Lexeme='PI' then begin              { ᫮ pi }
       Sym := number;
       Lexeme := ToStr(pi);
     end
     else
      if Lexeme = 'E' then begin            { ᫮ e }
        Sym := number;
        Lexeme := ToStr(exp(1));
      end
     else if Lexeme='SIN' then sym := _sin
     else if Lexeme='COS' then sym := _cos
     else if Lexeme='TG'  then sym := _tg
     else if Lexeme='LN'  then sym := _ln
     else if Lexeme='EXP' then sym := _exp
     else if Lexeme='SQRT' then sym := _sqrt
     else Check := false;
   end
  else
   case ch of
     '+' :  begin
              sym := plus;
              inc(ScanCount);
            end;
     '-' :  begin
              sym := minus;
              inc(ScanCount);
            end;
     '^' :  begin
              sym := step;
              inc(ScanCount);
            end;
     '*' :  begin
              sym := ast;
              inc(ScanCount);
            end;
     '/',
     ':' :  begin
              sym := dvt;
              inc(ScanCount);
            end;
     '(' :  begin
              sym := lparen;
              inc(ScanCount);
              inc(Counter);
            end;
     ')' :  begin
              sym := rparen;
              inc(ScanCount);
              dec(Counter);
            end;
     #0,
     #13 :  ;
    else Check := false;
  end;
  if not Check then ErrorCode := 2;
  Success := Check;
end;

procedure Term;forward;

procedure Expression;
var
  pl: boolean;
begin
  Term;
  if not Success then Exit;
  while (sym = plus) or (sym = minus) do  begin
    pl:=(sym=plus);
    Scan;
    if not Success then Exit;
    Term;
    if not Success then Exit;
    if pl then begin
      InStack('+',plus);
      if not Success then Exit;
    end
    else begin
      InStack('-',minus);
      if not Success then Exit;
    end;
  end;
end;

procedure Pwr;forward;

procedure Term;
var
  a: Token;
begin
  Pwr;
  if not Success  then Exit;
  while (sym = ast) or (sym = dvt) do  begin
    a:=sym;
    Scan;
    if not Success  then Exit;
    Pwr;
    if not Success  then Exit;
    case a of
      ast : begin
              InStack('*',ast);
              if not Success then Exit;
            end;
      dvt : begin
              InStack(':',dvt);
              if not Success then Exit;
            end;
    end;
  end;
end;

procedure Factor;

          procedure ExpressionInParens;
          begin
            Scan;
            if not Success  then Exit;
            Expression;
            if not Success  then Exit;
            if sym = rparen then begin
              Scan;
              if not Success then Exit;
            end
            else begin
              ErrorCode := 4;
              Success := false;
              Exit
            end
          end;
var
  TmpSym: Token;
begin
  if sym = number then begin {--- ᫮ ---}
    InStack(Lexeme,number);
    if not Success  then Exit;
    Scan;
    if not Success  then Exit;
  end
  else
   if sym = lparen then begin {--- ࠦ  ᪮ ---}
     ExpressionInParens;
     if not Success  then Exit;
   end  
  else				{--- 㭪 ---}
    if (sym in Functions) then begin
      TmpSym := sym;
      Scan;
      if not Success then Exit;
      if sym<>lparen then begin
        ErrorCode := 4;
        Success := false;
        Exit
      end;
      ExpressionInParens;
      if not Success  then Exit;
      InStack('',TmpSym);
      if not Success  then Exit;
    end
end;

procedure Pwr;
begin
  Factor;
  if not Success  then Exit;
  while sym = step do begin
    Scan;
    if not Success  then Exit;
    Factor;
    if not Success  then Exit;
    InStack('^',step);
    if not Success  then Exit;
  end;
end;

function Power(a,b: real): real;
var
  p: real;
begin
  p := exp(b*ln(abs(a)));
  if ( odd(round(b)) and (a<0) ) or ( (a<0) and (frac(b)<>0) )
    then p := - p;
  Power := p
end;

procedure Calculations(var Stroka: string);
{ ᮡ⢥  :  Stroka
  । ⠭ ப-ࠦ;
     頥 १   ப ᨬ }
var
  StrOp1, StrOp2, opr : Element;
  op1, op2       : real;
  i              : integer;
begin
  Success := false;
  ScanStr := Stroka;
  ScanLength := Length(ScanStr);

  if ScanLength=0 then begin
    ErrorCode := 1;
    exit;
  end;
  if ScanStr[ScanLength]='(' then begin
    ErrorCode := 4;
    exit;
  end;
  InitStack;

  ScanCount := 1;
  While ScanCount <> ScanLength do begin
    if ScanStr[ScanCount]='(' then
     if ScanStr[ScanCount+1]='-' then begin
       ScanStr:=copy(ScanStr,1,ScanCount) + '0' +
         copy(ScanStr,ScanCount+1,Length(ScanStr)-ScanCount);
       inc(ScanLength);
     end;
    inc(ScanCount);
  end;
  ScanCount:=1;
  Counter := 0; { 稪 ᪮ }
  ch := ' ';
  Scan;
  if not Success then Exit;

  Expression;
  if not Success then Exit;
  if Counter <> 0 then begin
    ErrorCode := 4;
    Success := false;
    Exit;
  end;

  Counter := 1;
  while Stack.StackCount > 1 do begin
    while not(
            (Stack.StackBody[Counter].TypeElement in Operations) or
            (Stack.StackBody[Counter].TypeElement in Functions)
             )
          do  inc(Counter);
    if Stack.StackBody[Counter].TypeElement in Operations
      then FromStack(StrOp1, StrOp2, opr, 2)
      else FromStack(StrOp1, StrOp2, opr, 1);
    if not Success then exit;
 
    val(StrOp1.TextElement, op1, i);
    if i<>0 then begin
       ErrorCode := 1;
       Success := false;
       Exit;
     end;
    val(StrOp2.TextElement, op2, i);
    if i<>0 then begin
       ErrorCode := 1;
       Success := false;
       Exit;
     end;
    case opr.TypeElement of
       plus  : Stack.StackBody[Counter].TextElement := ToStr(op1 + op2);
       minus : Stack.StackBody[Counter].TextElement := ToStr(op1 - op2);
       ast   : Stack.StackBody[Counter].TextElement := ToStr(op1 * op2);
       dvt   : if op2 = 0 then begin
                  ErrorCode := 5;
                  Success := false;
                  Exit;
                end
                else Stack.StackBody[Counter].TextElement := ToStr(op1 / op2);
        step : Stack.StackBody[Counter].TextElement := ToStr(Power(op1, op2));

        _sin : Stack.StackBody[Counter].TextElement := ToStr(sin(op2));
        _cos : Stack.StackBody[Counter].TextElement := ToStr(cos(op2));
        _tg  : if cos(op2)=0 then begin
                 ErrorCode := 5;
                 Success := false;
                 Exit;
               end
               else Stack.StackBody[Counter].TextElement := ToStr(sin(op2)/cos(op2));
         _ln : if op2<=0 then begin
                 ErrorCode := 6;
                 Success := false;
                 Exit;
               end
               else Stack.StackBody[Counter].TextElement := ToStr(ln(op2));
        _exp : Stack.StackBody[Counter].TextElement := ToStr(exp(op2));
       _sqrt : if op2<0 then begin
                  ErrorCode := 6;
                  Success := false;
                  Exit;
                end
                else Stack.StackBody[Counter].TextElement := ToStr(sqrt(op2));
    end;
  end;
  ScanStr := Stack.StackBody[1].TextElement;
  i:=1;
  while ScanStr[i]=' ' do inc(i);
  Stroka:=copy(ScanStr, i, Length(ScanStr)-i+1);
  Success := true;
end;

end.
